//+-------------------------------------------------------------------------------+ 
//|                   jurik rbci normalized.mq4                                           | 
//+-------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_level1     10
#property indicator_level2     50
#property indicator_level3     90
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    NormPeriod      = 100;
extern int    RbciPrice       = PRICE_MEDIAN;
extern int    SmoothLength    = 5;
extern double SmoothPhase     = 0;
extern bool   SmoothDouble    = true;
extern bool   Interpolate     = true;
extern bool   MultiColor      = true; 

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double norbci[];
double norbciDa[];
double norbciDb[];
double rbci[];
double price[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
  IndicatorBuffers(7);
    SetIndexBuffer(0,norbci);
    SetIndexBuffer(1,norbciDa);
    SetIndexBuffer(2,norbciDb);
    SetIndexBuffer(3,rbci);
    SetIndexBuffer(4,price);
    SetIndexBuffer(5,trend);
    
    //
    //
    //
    //
    //
    
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
    //
    //
    //
    //
    
    IndicatorShortName(timeFrameToString(timeFrame)+"  normalized jurik rbci ");
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,x,s,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { norbci[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if(calculateValue || timeFrame==Period())
   {
   if(MultiColor && !calculateValue && trend[limit]==-1) CleanPoint(limit,norbciDa,norbciDb);
   
   for (i=limit; i>=0; i--)
   {
      price[i] = iMA(NULL,0,1,0,MODE_SMA,RbciPrice,i);     
      rbci[i]  = iDSmooth(0.2596782922826*price[i]
 +0.2779778382802*price[i+1]
 +0.2887583020966*price[i+2]
 +0.2937732557634*price[i+3]
 +0.2897908362223*price[i+4]
 +0.2811001378238*price[i+5]
 +0.2626527012015*price[i+6]
 +0.2412109361523*price[i+7]
 +0.2099550512152*price[i+8]
 +0.1779981799386*price[i+9]
 +0.1367903753596*price[i+10]
 +0.0976163836175*price[i+11]
 +0.0502387036971*price[i+12]
 +0.00788445834270*price[i+13]
 -0.0413190597523*price[i+14]
 -0.0824733740371*price[i+15]
 -0.1290140559211*price[i+16]
 -0.1646744918273*price[i+17]
 -0.2043497711227*price[i+18]
 -0.2307304128455*price[i+19]
 -0.2600262513746*price[i+20]
 -0.2742222200417*price[i+21]
 -0.2906482636393*price[i+22]
 -0.2909236159714*price[i+23]
 -0.2932486958620*price[i+24]
 -0.2792111378713*price[i+25]
 -0.2675764124867*price[i+26]
 -0.2402217230731*price[i+27]
 -0.2161206339644*price[i+28]
 -0.1777423361592*price[i+29]
 -0.1438694707518*price[i+30]
 -0.0978423744292*price[i+31]
 -0.0578260346138*price[i+32]
 -0.00828453278323*price[i+33]
 +0.0336709295217*price[i+34]
 +0.0822286900365*price[i+35]
 +0.1217559812414*price[i+36]
 +0.1648997115437*price[i+37]
 +0.1978970092491*price[i+38]
 +0.2316898277105*price[i+39]
 +0.2547229015595*price[i+40]
 +0.2760995384064*price[i+41]
 +0.2867385565956*price[i+42]
 +0.2937995063519*price[i+43]
 +0.2908578585877*price[i+44]
 +0.2830509185235*price[i+45]
 +0.2667029003558*price[i+46]
 +0.2448744595481*price[i+47]
 +0.2166404148686*price[i+48]
 +0.1829515049799*price[i+49]
 +0.1455518738971*price[i+50]
 +0.1032671302987*price[i+51]
 +0.0603595540107*price[i+52]
 +0.01352958672309*price[i+53]
 -0.03064545020503*price[i+54]
 -0.0775774140395*price[i+55]
 -0.1186080661855*price[i+56]
 -0.1612370420273*price[i+57]
 -0.1949688426776*price[i+58]
 -0.2293545751748*price[i+59]
 -0.2522948965662*price[i+60]
 -0.2753425205365*price[i+61]
 -0.2850015711346*price[i+62]
 -0.2947594494722*price[i+63]
 -0.2898947698877*price[i+64]
 -0.2857405656727*price[i+65]
 -0.2664813269321*price[i+66]
 -0.2491782385987*price[i+67]
 -0.2170172808181*price[i+68]
 -0.1886350003271*price[i+69]
 -0.1462893501729*price[i+70]
 -0.1099974659827*price[i+71]
 -0.0611507987879*price[i+72]
 -0.02090477747824*price[i+73]
 +0.03014328721362*price[i+74]
 +0.0699929521436*price[i+75]
 +0.1187368200512*price[i+76]
 +0.1538742234981*price[i+77]
 +0.1960319282689*price[i+78]
 +0.2226022860947*price[i+79]
 +0.2545232004684*price[i+80]
 +0.2695147436256*price[i+81]
 +0.2885260024782*price[i+82]
 +0.2900700088071*price[i+83]
 +0.2947281908811*price[i+84]
 +0.2822878815071*price[i+85]
 +0.2725116803056*price[i+86]
 +0.2469415039236*price[i+87]
 +0.2240126531137*price[i+88]
 +0.1874820735168*price[i+89]
 +0.1539145610899*price[i+90]
 +0.1097036271111*price[i+91]
 +0.0689939982984*price[i+92]
 +0.02118043190420*price[i+93]
 -0.02253649405600*price[i+94]
 -0.0694684161197*price[i+95]
 -0.1118249236752*price[i+96]
 -0.1534158193597*price[i+97]
 -0.1902383588563*price[i+98]
 -0.2224837226927*price[i+99]
 -0.2502001525478*price[i+100]
 -0.2699372038026*price[i+101]
 -0.2859246418360*price[i+102]
 -0.2911385469064*price[i+103]
 -0.2939780361097*price[i+104]
 -0.2839978221668*price[i+105]
 -0.2736110754918*price[i+106]
 -0.2491762374374*price[i+107]
 -0.2268311904243*price[i+108]
 -0.1900225170204*price[i+109]
 -0.1582071738175*price[i+110]
 -0.1122484665323*price[i+111]
 -0.0744253352680*price[i+112]
 -0.02337519052909*price[i+113]
 +0.01635977682572*price[i+114]
 +0.0679963151542*price[i+115]
 +0.1053170653946*price[i+116]
 +0.1530194307129*price[i+117]
 +0.1837961500012*price[i+118]
 +0.2234600954541*price[i+119]
 +0.2441670105538*price[i+120]
 +0.2724956378202*price[i+121]
 +0.2805605273913*price[i+122]
 +0.2953767378351*price[i+123]
 +0.2894380579637*price[i+124]
 +0.2898882831792*price[i+125]
 +0.2699347858203*price[i+126]
 +0.2565643896244*price[i+127]
 +0.2239435353052*price[i+128]
 +0.1986367073694*price[i+129]
 +0.1559309338842*price[i+130]
 +0.1217210130378*price[i+131]
 +0.0725037786803*price[i+132]
 +0.0332724819825*price[i+133]
 -0.01823229626453*price[i+134]
 -0.0581375170143*price[i+135]
 -0.1074596024831*price[i+136]
 -0.1436529408625*price[i+137]
 -0.1865042691670*price[i+138]
 -0.2149922265731*price[i+139]
 -0.2476781451908*price[i+140]
 -0.2652517154868*price[i+141]
 -0.2850250325960*price[i+142]
 -0.2895753841560*price[i+143]
 -0.2948988420497*price[i+144]
 -0.2856258867690*price[i+145]
 -0.2763175755068*price[i+146]
 -0.2538111901327*price[i+147]
 -0.2310587979322*price[i+148]
 -0.1972447964779*price[i+149]
 -0.1634873468125*price[i+150]
 -0.1214434008942*price[i+151]
 -0.0801320106865*price[i+152]
 -0.0337913105671*price[i+153]
 +0.01094773517497*price[i+154]
 +0.0571764105785*price[i+155]
 +0.1009434797454*price[i+156]
 +0.1426025127339*price[i+157]
 +0.1811522543813*price[i+158]
 +0.2141674409783*price[i+159]
 +0.2438206370698*price[i+160]
 +0.2648970761521*price[i+161]
 +0.2828966844511*price[i+162]
 +0.2898399401990*price[i+163]
 +0.2946167422595*price[i+164]
 +0.2865481331558*price[i+165]
 +0.2778702110835*price[i+166]
 +0.2553153121391*price[i+167]
 +0.2343068923377*price[i+168]
 +0.1991485985669*price[i+169]
 +0.1681765179661*price[i+170]
 +0.1234771207086*price[i+171]
 +0.0859160528984*price[i+172]
 +0.0356254586456*price[i+173]
 -0.00447516954331*price[i+174]
 -0.0558969229110*price[i+175]
 -0.0942118363436*price[i+176]
 -0.1422213065967*price[i+177]
 -0.1745752269833*price[i+178]
 -0.2149803003261*price[i+179]
 -0.2377592414812*price[i+180]
 -0.2671198459574*price[i+181]
 -0.2776277965090*price[i+182]
 -0.2935838522833*price[i+183]
 -0.2903101059989*price[i+184]
 -0.2918050033873*price[i+185]
 -0.2745760960345*price[i+186]
 -0.2619541004640*price[i+187]
 -0.2319555395832*price[i+188]
 -0.2069237268234*price[i+189]
 -0.1665893646007*price[i+190]
 -0.1320478079498*price[i+191]
 -0.0848275764094*price[i+192]
 -0.0445842689429*price[i+193]
 +0.00538717928943*price[i+194]
 +0.0469890171593*price[i+195]
 +0.0952905881317*price[i+196]
 +0.1337966762447*price[i+197]
 +0.1761473555949*price[i+198]
 +0.2074268702852*price[i+199]
 +0.2400990606508*price[i+200]
 +0.2607473736890*price[i+201]
 +0.2809268991369*price[i+202]
 +0.2885974998832*price[i+203]
 +0.2946553007603*price[i+204]
 +0.2882887362384*price[i+205]
 +0.2799378448366*price[i+206]
 +0.2598655082077*price[i+207]
 +0.2381880248102*price[i+208]
 +0.2061007703705*price[i+209]
 +0.1734421707339*price[i+210]
 +0.1322268538729*price[i+211]
 +0.0919678299666*price[i+212]
 +0.0454276892866*price[i+213]
 +0.001655607506068*price[i+214]
 -0.0458583218839*price[i+215]
 -0.0887465182222*price[i+216]
 -0.1327571417750*price[i+217]
 -0.1704820999039*price[i+218]
 -0.2068201843179*price[i+219]
 -0.2356359633941*price[i+220]
 -0.2608441074769*price[i+221]
 -0.2779023200096*price[i+222]
 -0.2895697704218*price[i+223]
 -0.2931967001052*price[i+224]
 -0.2901925445180*price[i+225]
 -0.2800523122705*price[i+226]
 -0.2626344741507*price[i+227]
 -0.2397623507461*price[i+228]
 -0.2095518927541*price[i+229]
 -0.1762544273767*price[i+230]
 -0.1360777682524*price[i+231]
 -0.0957093013918*price[i+232]
 -0.0493237895657*price[i+233]
 -0.00596089775222*price[i+234]
 +0.0423094854046*price[i+235]
 +0.0842641658344*price[i+236]
 +0.1299474812057*price[i+237]
 +0.1661937424489*price[i+238]
 +0.2051023940384*price[i+239]
 +0.2318617898831*price[i+240]
 +0.2604964063091*price[i+241]
 +0.2748818144841*price[i+242]
 +0.2907674661740*price[i+243]
 +0.2910670467048*price[i+244]
 +0.2929891715646*price[i+245]
 +0.2788371398284*price[i+246]
 +0.2669543390308*price[i+247]
 +0.2393718979521*price[i+248]
 +0.2151947686413*price[i+249]
 +0.1764970889516*price[i+250]
 +0.1427353119519*price[i+251]
 +0.0963134004161*price[i+252]
 +0.0566061271973*price[i+253]
 +0.00660452786323*price[i+254]
 -0.0348395364446*price[i+255]
 -0.0839181750292*price[i+256]
 -0.1227358209810*price[i+257]
 -0.1664611862147*price[i+258]
 -0.1985643654562*price[i+259]
 -0.2330023918086*price[i+260]
 -0.2549805853966*price[i+261]
 -0.2770699040521*price[i+262]
 -0.2865259646703*price[i+263]
 -0.2943705242353*price[i+264]
 -0.2901572642139*price[i+265]
 -0.2832068408287*price[i+266]
 -0.2655413202811*price[i+267]
 -0.2446424624239*price[i+268]
 -0.2150868513923*price[i+269]
 -0.1823993267927*price[i+270]
 -0.1437102109734*price[i+271]
 -0.1024970293129*price[i+272]
 -0.0583578360246*price[i+273]
 -0.01266915246784*price[i+274]
 +0.0326682531839*price[i+275]
 +0.0783867772597*price[i+276]
 +0.1205164412842*price[i+277]
 +0.1618529290368*price[i+278]
 +0.1966447785183*price[i+279]
 +0.2296465407277*price[i+280]
 +0.2536501333828*price[i+281]
 +0.2752040200225*price[i+282]
 +0.2859867811522*price[i+283]
 +0.2941176821906*price[i+284]
 +0.2905047026128*price[i+285]
 +0.2845633320173*price[i+286]
 +0.2667553624202*price[i+287]
 +0.2474771939304*price[i+288]
 +0.2170352988426*price[i+289]
 +0.1864650183035*price[i+290]
 +0.1461632973284*price[i+291]
 +0.1074521826120*price[i+292]
 +0.0610127711281*price[i+293]
 +0.01810874091205*price[i+294]
 -0.03015527487973*price[i+295]
 -0.0728947854762*price[i+296]
 -0.1184939704926*price[i+297]
 -0.1567286587559*price[i+298]
 -0.1954291993150*price[i+299]
 -0.2252605840610*price[i+300]
 -0.2534917909523*price[i+301]
 -0.2718446516184*price[i+302]
 -0.2870425282719*price[i+303]
 -0.2919660099258*price[i+304]
 -0.2928196094994*price[i+305]
 -0.2836787210896*price[i+306]
 -0.2702554301793*price[i+307]
 -0.2477943217884*price[i+308]
 -0.2215319318573*price[i+309]
 -0.1878028067357*price[i+310]
 -0.1513691313597*price[i+311]
 -0.1095337178801*price[i+312]
 -0.0665673356364*price[i+313]
 -0.02059024180920*price[i+314]
 +0.02465254987667*price[i+315]
 +0.0703887574214*price[i+316]
 +0.1134466159986*price[i+317]
 +0.1545671496899*price[i+318]
 +0.1912060581129*price[i+319]
 +0.2237690321470*price[i+320]
 +0.2503925310049*price[i+321]
 +0.2712720962503*price[i+322]
 +0.2852696852501*price[i+323]
 +0.2924598888025*price[i+324],SmoothLength,SmoothPhase,SmoothDouble,i,0);
 
        double hi  = rbci[ArrayMaximum(rbci,NormPeriod,i)];
        double lo  = rbci[ArrayMinimum(rbci,NormPeriod,i)];
    
     if (hi!=lo)
          norbci[i]   = iDSmooth(100*(rbci[i]- lo)/(hi - lo),SmoothLength,SmoothPhase,SmoothDouble,i, 20);        
     else norbci[i]   = iDSmooth(0,                          SmoothLength,SmoothPhase,SmoothDouble,i, 20); 
          norbciDa[i] = EMPTY_VALUE;
          norbciDb[i] = EMPTY_VALUE;    
          trend[i]    = trend[i+1];
 
      if (norbci[i] > norbci[i+1]) trend[i]=  1;
      if (norbci[i] < norbci[i+1]) trend[i]= -1;    
      if (MultiColor && !calculateValue && trend[i]==-1) PlotPoint(i,norbciDa,norbciDb,norbci); 
              
      }
      
      manageAlerts();
      return(0);          
      }
      
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (MultiColor && trend[limit]==-1) CleanPoint(limit,norbciDa,norbciDb);

      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         norbci[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NormPeriod,RbciPrice,SmoothLength,SmoothPhase,SmoothDouble,0,y);
         norbciDa[i] = EMPTY_VALUE;
         norbciDb[i] = EMPTY_VALUE;
         trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NormPeriod,RbciPrice,SmoothLength,SmoothPhase,SmoothDouble,5,y);    
         
         //
         //
         //
         //
         //
            
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(x = 1; i+x < Bars && Time[i+x] >= time; x++) continue;	
            for(s = 1; s < x; s++)
            {
  	             norbci[i+s] = norbci[i] + (norbci[i+x] - norbci[i]) * s/x;
  	             
  	         }              
   }
   if (MultiColor) for (i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,norbciDa,norbciDb,norbci);
   manageAlerts();
   return(0);
}

//+-----------------------------------------------------------------------------------------
//|                                                                 
//+-----------------------------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double tprice, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(tprice,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(tprice,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double tprice, double length, double phase, int i, int s=0)
{
   if (length <=1) return(tprice);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=tprice; for(; k<10; k++) wrk[r][k+s]=0; return(tprice); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = tprice - wrk[r-1][bsmax+s];
      double del2   = tprice - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = tprice; else wrk[r][bsmax+s] = tprice - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = tprice; else wrk[r][bsmin+s] = tprice - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = tprice + alpha*(wrk[r-1][0+s]-tprice);
         wrk[r][1+s] = (tprice - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"sloping up");
         if (trend[whichBar]==-1) doAlert(whichBar,"sloping down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rbci ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rbci "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
string stringUpperCase(string str) { string s = str; StringToUpper(s); return(s); }           